"use strict";
(function () {
  angular
    .module("cybersponse")
    .controller("editCardTiles100Ctrl", editCardTiles100Ctrl);

    editCardTiles100Ctrl.$inject = [
    "$scope",
    "$uibModalInstance",
    "config",
    "appModulesService",
    "Entity",
  ];

  function editCardTiles100Ctrl(
    $scope,
    $uibModalInstance,
    config,
    appModulesService,
    Entity
  ) {
    $scope.cancel = cancel;
    $scope.save = save;
    $scope.loadAttributes = loadAttributes;
    function _init(){
      var _config = {
        mapping: {
            cardHeader:null,
            cardTitle: null,
            subtitle1: null,
            subtitle2: null,
            showIcon: false,
            cardIcon: 'fa fa-none',
            cardDetails: null,
            cardLeftBorder: null
          }};
      $scope.config = {};
      angular.extend($scope.config, _config, config);
      $scope.pageConfig = {
        maxRecordSize: [5, 10, 20, 30, 40, 50, 100, 200],
      };
      appModulesService.load(true).then(function (modules) {
        $scope.modules = modules;
        if ($scope.config.module !== "") {
          loadAttributes();
        }
      });
    }
    function loadAttributes() {
      $scope.fields = [];
      $scope.fieldsArray = [];
      $scope.pickListFields = [];
      var entity = new Entity($scope.config.module);
      entity.loadFields().then(function () {
        for (var key in entity.fields) {
          if (entity.fields[key].type === "picklist") {
            $scope.pickListFields.push(entity.fields[key]);
          }
        }
        $scope.fields = entity.getFormFields();
        angular.extend($scope.fields, entity.getRelationshipFields());
        $scope.fieldsArray = entity.getFormFieldsArray();
      });
    }
    function cancel() {
      $uibModalInstance.dismiss("cancel");
    }

    function save() {
      if ($scope.editCardTilesWidgetForm.$invalid) {
        $scope.editCardTilesWidgetForm.$setTouched();
        $scope.editCardTilesWidgetForm.$focusOnFirstError();
        return;
      }
      $uibModalInstance.close($scope.config);
    }
    _init();
  }
})();